unit TestuMy2DMatrix;
{

  Delphi DUnit Test Case
  ----------------------
  This unit contains a skeleton test case class generated by the Test Case Wizard.
  Modify the generated code to correctly setup and call the methods from the unit 
  being tested.

}

interface

uses
  TestFramework, uMy2DMatrix, System.Sysutils;

type
  // Test methods for class TMatrixTest

  TestTMatrixTest = class(TTestCase)
  strict private
    FMatrixTest: TMatrixTest;
  public
    procedure SetUp; override;
    procedure TearDown; override;
  published
    procedure TestAsText;
    procedure TestScalarMultipy;
    procedure TestMatrixAdd;
    procedure TestMatrixSubtract;
  end;

implementation
uses
  System.Classes;

procedure TestTMatrixTest.SetUp;
var
  J: Integer;
  I: Integer;
begin
  FMatrixTest := TMatrixTest.Create;
  FMatrixTest.Initialize(3,5);
  for I := 0 to 2 do
    for J := 0 to 4 do
      FMatrixTest.Data[I, J] := I*J;
end;

procedure TestTMatrixTest.TearDown;
begin
  FMatrixTest.Free;
  FMatrixTest := nil;
end;

procedure TestTMatrixTest.TestAsText;
var
  LLines: TStringList;
begin
  LLines := TStringList.Create;
  LLines.Text := FMatrixTest.AsText;
  Check(LLines.Count = 5, 'Expected 5 lines of text');
  Check(LLines[4] = '', 'Expect the last line to be blank');
end;

procedure TestTMatrixTest.TestMatrixAdd;
var
  LResult: TMy2DMatrix;
  I: Integer;
  J: Integer;
begin
  LResult := FMatrixTest.Matrix + FMatrixTest.Matrix;
  for I := 0 to 2 do
    for J := 0 to 4 do
      Check( (FMatrixTest.Data[I, J]*2) = LResult.Data[I, J], 'Expect each respective element in the result matrix to be double that in the source');
end;

procedure TestTMatrixTest.TestMatrixSubtract;
var
  LResult: TMy2DMatrix;
  I: Integer;
  J: Integer;
begin
  LResult := (FMatrixTest.Matrix*2) - FMatrixTest.Matrix;
  for I := 0 to 2 do
    for J := 0 to 4 do
      Check(FMatrixTest.Matrix = LResult, 'Expect the result matrix to be the same as the source');
end;

procedure TestTMatrixTest.TestScalarMultipy;
var
  LResult: TMy2DMatrix;
  I: Integer;
  J: Integer;
begin
  LResult := FMatrixTest.Matrix * 2;
  for I := 0 to 2 do
    for J := 0 to 4 do
      Check( FMatrixTest.Data[I, J]*2 = LResult.Data[I, J], 'Expect each respective element in the result matrix to be double that in the source');
end;

initialization
  // Register any test cases with the test runner
  RegisterTest(TestTMatrixTest.Suite);
end.

