unit Unit1;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Rtti, System.Classes,
  System.Variants, FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs, FMX.StdCtrls;

type
  TFactoryClass = (Class1, Class2);
  TBaseClass = class
    function WhatAmI: string;
  end;

  TDescendantClass1 = class(TBaseClass)

  end;

  TDescendantClass2 = class(TBaseClass)

  end;

  TFactory = record
    class operator Implicit(A: TFactory): TDescendantClass1;
    class operator Implicit(A: TFactory): TDescendantClass2;
    class operator Implicit(A: TFactory): TBaseClass;
  public
    function InstanceOf(AClass: TFactoryClass): TBaseClass;
  end;

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Button3: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    FFactory : TFactory;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.fmx}

{ TBaseClass }

function TBaseClass.WhatAmI: string;
begin
  Result := format('I am a %s', [ClassName]);
end;

{ TFactory }

class operator TFactory.Implicit(A: TFactory): TDescendantClass1;
begin
  Result := TDescendantClass1.Create;
end;

class operator TFactory.Implicit(A: TFactory): TDescendantClass2;
begin
  Result := TDescendantClass2.Create;
end;

class operator TFactory.Implicit(A: TFactory): TBaseClass;
begin
  Result := TBaseClass.Create;
end;

function TFactory.InstanceOf(AClass: TFactoryClass): TBaseClass;
begin
  case AClass of
    Class1: Result := TDescendantClass1.Create;
    Class2: Result := TDescendantClass2.Create;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  LInstance: TDescendantClass1;
begin
  LInstance := FFactory;
  Label1.Text := LInstance.WhatAmI;
  LInstance.Free;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  LInstance: TDescendantClass2;
begin
 LInstance := FFactory;
 Label1.Text := LInstance.WhatAmI;
 LInstance.Free;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  LInst: TBaseClass;
begin
  LInst := FFactory.InstanceOf(Class2);
  Label1.Text := LInst.WhatAmI;
end;

end.
