unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

type
  TMyDateConversion = record
    class operator Implicit(a: string): TMyDateConversion;
    class operator Implicit(a: TMyDateConversion): string;
    class operator Implicit(a: TDateTime): TMyDateConversion;
  private
    FTimestamp: TDateTime;
    procedure SetTimestamp(const Value: TDateTime);
    function GetAsString: string;
  public
    property Timestamp: TDateTime read FTimestamp write SetTimestamp;
    property AsString: string read GetAsString;
  end;

  TForm1 = class(TForm)
    Label1: TLabel;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation
uses
  System.Rtti;
{$R *.dfm}

{ TMyDateConversion }

class operator TMyDateConversion.Implicit(a: string): TMyDateConversion;
begin
  Result.Timestamp := StrToDateTimeDef(a, Now);
end;

class operator TMyDateConversion.Implicit(a: TMyDateConversion): string;
begin
  Result := FormatDateTime(FormatSettings.LongTimeFormat, a.Timestamp);
end;

function TMyDateConversion.GetAsString: string;
begin
  Result := Self;
end;

class operator TMyDateConversion.Implicit(a: TDateTime): TMyDateConversion;
begin
  Result.Timestamp := a;
end;

procedure TMyDateConversion.SetTimestamp(const Value: TDateTime);
begin
  FTimestamp := Value;
end;

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  LConverter: TMyDateConversion;
begin
  LConverter := Now;
  Label1.Caption := LConverter.AsString;
end;

end.
